<?php

namespace Drupal\syncloud\Hook;

/**
 * @file
 * Contains \Drupal\syncloud\Hook.
 */

use Drupal\Core\Entity\EntityInterface;

/**
 * Class PageAttachmentsAlter.
 */
class ContactMessageInsert {
  /**
   * Hook.
   */
  public static function hook(EntityInterface $entity) {
    if ($entity->getEntityType()->id() == 'contact_message') {
      $form_id = $entity->getContactForm()->id();
      $syn_storage = \Drupal::entityTypeManager()->getStorage('syn');
      $ip = \Drupal::request()->getClientIp();
      $config =  \Drupal::configFactory()->get('syncloud.settings');
      if ($config->get('telegram-int')) {
        $uuid = \Drupal::state()->get('syncloud.uuid');
        $current_path = \Drupal::service('path.current')->getPath();
        $alias = \Drupal::service('path_alias.manager')->getAliasByPath($current_path);
        $msg = [
          'ip' => $ip,
          'type' => $form_id,
          'host' => \Drupal::request()->getHost(),
          'page' => \Drupal::request()->getSchemeAndHttpHost() . $alias,
        ];
        foreach ($entity->getFields() as $name => $field) {
          $msg['message--' . $name] = $field->getString();
        }
        \Drupal::service('syncloud.mqtt')->run()->publish("\$telega/syncloud/$uuid/event/contact-message", json_encode($msg));
      }

      $syn_array = [
        'name' => $ip . '--' . $form_id,
        'ip' => $ip,
        'host' => \Drupal::request()->getHost(),
        'page' => \Drupal::request()->getSchemeAndHttpHost(),
        'type' => $form_id,
        'message' => $entity->id(),
        'city' => [],
        'url' => \Drupal::service('path.current')->getPath(),
      ];
      $syn = $syn_storage->create($syn_array);
      $syn_storage->save($syn);
    }
  }

}
